diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index d7e4749..e01a9ec 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -4564,1256 +3670,719 @@ _cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_ope
     char csnStr[CSN_STRSIZE];
     PRIntervalTime interval;
     CL5Entry entry;
-    CL5DBFile *file = NULL;
-    Object *file_obj = NULL;
     DB_TXN *txnid = NULL;
     DB_TXN *parent_txnid = (DB_TXN *)txn;
 
-    rc = _cl5GetDBFileByReplicaName(replName, replGen, &file_obj);
-    if (rc == CL5_NOTFOUND) {
-        rc = _cl5DBOpenFileByReplicaName(replName, replGen, &file_obj,
-                                         PR_TRUE /* check for duplicates */);
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5WriteOperationTxn - Failed to find or open DB object for replica %s\n", replName);
-            return rc;
-        }
-    } else if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5WriteOperationTxn - Failed to get db file for target dn (%s)",
-                      REPL_GET_DN(&op->target_address));
-        return CL5_OBJSET_ERROR;
-    }
-
-    /* assign entry time - used for trimming */
-    entry.time = slapi_current_utc_time();
-    entry.op = (slapi_operation_parameters *)op;
-
-    /* construct the key */
-    key.data = csn_as_string(op->csn, PR_FALSE, csnStr);
-    key.size = CSN_STRSIZE;
-
-    /* construct the data */
-    data = (DBT *)slapi_ch_calloc(1, sizeof(DBT));
-    rc = _cl5Entry2DBData(&entry, (char **)&data->data, &data->size);
-    if (rc != CL5_SUCCESS) {
-        char s[CSN_STRSIZE];
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5WriteOperationTxn - Failed to convert entry with csn (%s) "
-                      "to db format\n",
-                      csn_as_string(op->csn, PR_FALSE, s));
-        goto done;
-    }
-
-    file = (CL5DBFile *)object_get_data(file_obj);
-    PR_ASSERT(file);
-
-    /* if this is part of ldif2cl - just write the entry without transaction */
-    if (s_cl5Desc.dbOpenMode == CL5_OPEN_LDIF2CL) {
-        rc = file->db->put(file->db, NULL, &key, data, 0);
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5WriteOperationTxn - Failed to write entry; db error - %d %s\n",
-                          rc, db_strerror(rc));
-            if (CL5_OS_ERR_IS_DISKFULL(rc)) {
-                cl5_set_diskfull();
-            }
-            rc = CL5_DB_ERROR;
-        }
-        goto done;
-    }
-
-    /* write the entry */
-    rc = EAGAIN;
-    cnt = 0;
-
-    while ((rc == EAGAIN || rc == DB_LOCK_DEADLOCK) && cnt < MAX_TRIALS) {
-        if (cnt != 0) {
-            /* abort previous transaction */
-            rc = TXN_ABORT(txnid);
-            if (rc != 0) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5WriteOperationTxn - Failed to abort transaction; db error - %d %s\n",
-                              rc, db_strerror(rc));
-                rc = CL5_DB_ERROR;
-                goto done;
-            }
-            /* back off */
-            interval = PR_MillisecondsToInterval(slapi_rand() % 100);
-            DS_Sleep(interval);
-        }
-        /* begin transaction */
-        rc = TXN_BEGIN(s_cl5Desc.dbEnv, parent_txnid, &txnid, 0);
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5WriteOperationTxn - Failed to start transaction; db error - %d %s\n",
-                          rc, db_strerror(rc));
-            rc = CL5_DB_ERROR;
-            goto done;
-        }
-
-        rc = file->db->put(file->db, txnid, &key, data, 0);
-        if (CL5_OS_ERR_IS_DISKFULL(rc)) {
-            slapi_log_err(SLAPI_LOG_CRIT, repl_plugin_name_cl,
-                          "_cl5WriteOperationTxn - Changelog (%s) DISK FULL; db error - %d %s\n",
-                          s_cl5Desc.dbDir, rc, db_strerror(rc));
-            cl5_set_diskfull();
-            rc = CL5_DB_ERROR;
-            goto done;
-        }
-        if (cnt != 0) {
-            if (rc == 0) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "_cl5WriteOperationTxn - "
-                                                                  "retry (%d) the transaction (csn=%s) succeeded\n",
-                              cnt, (char *)key.data);
-            } else if ((cnt + 1) >= MAX_TRIALS) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "_cl5WriteOperationTxn - "
-                                                                  "retry (%d) the transaction (csn=%s) failed (rc=%d (%s))\n",
-                              cnt, (char *)key.data, rc, db_strerror(rc));
-            }
-        }
-        cnt++;
-    }
-
-    if (rc == 0) /* we successfully added entry */
-    {
-        rc = TXN_COMMIT(txnid);
-    } else {
-        char s[CSN_STRSIZE];
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5WriteOperationTxn - Failed to write entry with csn (%s); "
-                      "db error - %d %s\n",
-                      csn_as_string(op->csn, PR_FALSE, s),
-                      rc, db_strerror(rc));
-        rc = TXN_ABORT(txnid);
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5WriteOperationTxn - Failed to abort transaction; db error - %d %s\n",
-                          rc, db_strerror(rc));
-        }
-        rc = CL5_DB_ERROR;
-        goto done;
-    }
-
-    /* update entry count - we assume that all entries are new */
-    PR_AtomicIncrement(&file->entryCount);
-
-    /* update purge vector if we have not seen any changes from this replica before */
-    _cl5UpdateRUV(file_obj, op->csn, PR_TRUE, PR_TRUE);
-
-    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                  "cl5WriteOperationTxn - Successfully written entry with csn (%s)\n", csnStr);
-    rc = CL5_SUCCESS;
-done:
-    if (data->data)
-        slapi_ch_free(&(data->data));
-    slapi_ch_free((void **)&data);
-
-    if (file_obj)
-        object_release(file_obj);
-
-    return rc;
-}
-
-static int
-_cl5WriteOperation(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local)
-{
-    return _cl5WriteOperationTxn(replName, replGen, op, local, NULL);
-}
-
-static int
-_cl5GetFirstEntry(Object *file_obj, CL5Entry *entry, void **iterator, DB_TXN *txnid)
-{
-    int rc;
-    DBC *cursor = NULL;
-    DBT key = {0}, data = {0};
-    CL5Iterator *it;
-    CL5DBFile *file;
-
-    PR_ASSERT(file_obj && entry && iterator);
-
-    file = (CL5DBFile *)object_get_data(file_obj);
-    PR_ASSERT(file);
-    /* create cursor */
-    rc = file->db->cursor(file->db, txnid, &cursor, 0);
-    if (rc != 0) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5GetFirstEntry - Failed to create cursor; db error - %d %s\n", rc, db_strerror(rc));
-        rc = CL5_DB_ERROR;
-        goto done;
-    }
-
-    key.flags = DB_DBT_MALLOC;
-    data.flags = DB_DBT_MALLOC;
-    while ((rc = cursor->c_get(cursor, &key, &data, DB_NEXT)) == 0) {
-        /* skip service entries */
-        if (cl5HelperEntry((char *)key.data, NULL)) {
-            slapi_ch_free(&(key.data));
-            slapi_ch_free(&(data.data));
-            continue;
-        }
-
-        /* format entry */
-        slapi_ch_free(&(key.data));
-        rc = cl5DBData2Entry(data.data, data.size, entry);
-        slapi_ch_free(&(data.data));
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5GetFirstOperation - Failed to format entry: %d\n", rc);
-            goto done;
-        }
-
-        it = (CL5Iterator *)slapi_ch_malloc(sizeof(CL5Iterator));
-        it->cursor = cursor;
-        object_acquire(file_obj);
-        it->file = file_obj;
-        *(CL5Iterator **)iterator = it;
-
-        return CL5_SUCCESS;
-    }
-    /*
-     * Bug 430172 - memory leaks after db "get" deadlocks, e.g. in CL5 trim
-     * Even when db->c_get() does not return success, memory may have been
-     * allocated in the DBT.  This seems to happen when DB_DBT_MALLOC was set,
-     * the data being retrieved is larger than the page size, and we got
-     * DB_LOCK_DEADLOCK. libdb allocates the memory and then finds itself
-     * deadlocked trying to go through the overflow page list.  It returns
-     * DB_LOCK_DEADLOCK which we've assumed meant that no memory was allocated
-     * for the DBT.
-     *
-     * The following slapi_ch_free frees the memory only when the value is
-     * non NULL, which is true if the situation described above occurs.
-     */
-    slapi_ch_free((void **)&key.data);
-    slapi_ch_free((void **)&data.data);
-
-    /* walked of the end of the file */
-    if (rc == DB_NOTFOUND) {
-        rc = CL5_NOTFOUND;
-        goto done;
-    }
-
-    /* db error occured while iterating */
-    /* On this path, the condition "rc != 0" cannot be false */
-    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                  "_cl5GetFirstEntry - Failed to get entry; db error - %d %s\n",
-                  rc, db_strerror(rc));
-    rc = CL5_DB_ERROR;
-
-done:
-    /* error occured */
-    /* We didn't success in assigning this cursor to the iterator,
-     * so we need to free the cursor here */
-    if (cursor)
-        cursor->c_close(cursor);
-
-    return rc;
-}
-
-static int
-_cl5GetNextEntry(CL5Entry *entry, void *iterator)
-{
-    int rc;
-    CL5Iterator *it;
-    DBT key = {0}, data = {0};
-
-    PR_ASSERT(entry && iterator);
-
-    it = (CL5Iterator *)iterator;
-
-    key.flags = DB_DBT_MALLOC;
-    data.flags = DB_DBT_MALLOC;
-    while ((rc = it->cursor->c_get(it->cursor, &key, &data, DB_NEXT)) == 0) {
-        if (cl5HelperEntry((char *)key.data, NULL)) {
-            slapi_ch_free(&(key.data));
-            slapi_ch_free(&(data.data));
-            continue;
-        }
-
-        slapi_ch_free(&(key.data));
-        /* format entry */
-        rc = cl5DBData2Entry(data.data, data.size, entry);
-        slapi_ch_free(&(data.data));
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5GetNextEntry - Failed to format entry: %d\n", rc);
-        }
-
-        return rc;
-    }
-    /*
-     * Bug 430172 - memory leaks after db "get" deadlocks, e.g. in CL5 trim
-     * Even when db->c_get() does not return success, memory may have been
-     * allocated in the DBT.  This seems to happen when DB_DBT_MALLOC was set,
-     * the data being retrieved is larger than the page size, and we got
-     * DB_LOCK_DEADLOCK. libdb allocates the memory and then finds itself
-     * deadlocked trying to go through the overflow page list.  It returns
-     * DB_LOCK_DEADLOCK which we've assumed meant that no memory was allocated
-     * for the DBT.
-     *
-     * The following slapi_ch_free frees the memory only when the value is
-     * non NULL, which is true if the situation described above occurs.
-     */
-    slapi_ch_free((void **)&key.data);
-    slapi_ch_free((void **)&data.data);
-
-    /* walked of the end of the file or entry is out of range */
-    if (rc == 0 || rc == DB_NOTFOUND) {
-        return CL5_NOTFOUND;
-    }
-
-    /* cursor operation failed */
-    slapi_log_err(rc == CL5_DB_LOCK_ERROR ? SLAPI_LOG_REPL : SLAPI_LOG_ERR,
-                  repl_plugin_name_cl,
-                  "_cl5GetNextEntry - Failed to get entry; db error - %d %s\n",
-                  rc, db_strerror(rc));
-
-    return rc;
-}
-
-static int
-_cl5CurrentDeleteEntry(void *iterator)
-{
-    int rc;
-    CL5Iterator *it;
-    CL5DBFile *file;
-
-    PR_ASSERT(iterator);
-
-    it = (CL5Iterator *)iterator;
-
-    rc = it->cursor->c_del(it->cursor, 0);
-
-    if (rc == 0) {
-        /* decrement entry count */
-        file = (CL5DBFile *)object_get_data(it->file);
-        PR_AtomicDecrement(&file->entryCount);
-        return CL5_SUCCESS;
-    } else {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5CurrentDeleteEntry - Failed, err=%d %s\n",
-                      rc, db_strerror(rc));
-        /*
-         * We don't free(close) the cursor here, as the caller will free it by
-         * a call to cl5DestroyIterator.  Freeing it here is a potential bug,
-         * as the cursor can't be referenced later once freed.
-         */
-        return rc;
-    }
-}
-
-PRBool
-cl5HelperEntry(const char *csnstr, CSN *csnp)
-{
-    CSN *csn;
-    time_t csnTime;
-    PRBool retval = PR_FALSE;
-
-    if (csnp) {
-        csn = csnp;
-    } else {
-        csn = csn_new_by_string(csnstr);
-    }
-    if (csn == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5HelperEntry - Failed to get csn time; csn error\n");
-        return PR_FALSE;
-    }
-    csnTime = csn_get_time(csn);
-
-    if (csnTime == ENTRY_COUNT_TIME || csnTime == PURGE_RUV_TIME) {
-        retval = PR_TRUE;
-    }
-
-    if (NULL == csnp)
-        csn_free(&csn);
-    return retval;
-}
-
-#ifdef FOR_DEBUGGING
-/* Replay iteration helper functions */
-static PRBool
-_cl5ValidReplayIterator(const CL5ReplayIterator *iterator)
-{
-    if (iterator == NULL ||
-        iterator->consumerRuv == NULL || iterator->supplierRuvObj == NULL ||
-        iterator->fileObj == NULL)
-        return PR_FALSE;
-
-    return PR_TRUE;
-}
-#endif
-
-/* Algorithm: ONREPL!!!
- */
-struct replica_hash_entry
-{
-    ReplicaId rid;      /* replica id */
-    PRBool sendChanges; /* indicates whether changes should be sent for this replica */
-};
-
-
-static int
-_cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Replica *replica, Object *fileObj, CL5ReplayIterator **iterator, int *continue_on_missing)
-{
-    CLC_Buffer *clcache = NULL;
-    CL5DBFile *file;
-    CSN *startCSN = NULL;
-    char csnStr[CSN_STRSIZE];
-    int rc = CL5_SUCCESS;
-    Object *supplierRuvObj = NULL;
-    RUV *supplierRuv = NULL;
-    PRBool haveChanges = PR_FALSE;
-    char *agmt_name;
-
-    PR_ASSERT(consumerRuv && replica && fileObj && iterator);
-    csnStr[0] = '\0';
-
-    file = (CL5DBFile *)object_get_data(fileObj);
-
-    /* get supplier's RUV */
-    supplierRuvObj = replica_get_ruv(replica);
-    PR_ASSERT(supplierRuvObj);
-
-    if (!supplierRuvObj) {
-        rc = CL5_UNKNOWN_ERROR;
-        goto done;
-    }
-
-    supplierRuv = (RUV *)object_get_data(supplierRuvObj);
-    PR_ASSERT(supplierRuv);
-
-    agmt_name = get_thread_private_agmtname();
-
-    if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5PositionCursorForReplay - (%s): Consumer RUV:\n", agmt_name);
-        ruv_dump(consumerRuv, agmt_name, NULL);
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5PositionCursorForReplay - (%s): Supplier RUV:\n", agmt_name);
-        ruv_dump(supplierRuv, agmt_name, NULL);
-    }
+    /* assign entry time - used for trimming */
+    entry.time = slapi_current_utc_time();
+    entry.op = (slapi_operation_parameters *)op;
 
+    /* construct the key */
+    key.data = csn_as_string(op->csn, PR_FALSE, csnStr);
+    key.size = CSN_STRSIZE;
 
-    /* initialize the changelog buffer and do the initial load */
+    /* construct the data */
+    data = (DBT *)slapi_ch_calloc(1, sizeof(DBT));
+    rc = _cl5Entry2DBData(&entry, (char **)&data->data, &data->size, cldb->clcrypt_handle);
+    if (rc != CL5_SUCCESS) {
+        char s[CSN_STRSIZE];
+        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                      "_cl5WriteOperationTxn - Failed to convert entry with csn (%s) "
+                      "to db format\n",
+                      csn_as_string(op->csn, PR_FALSE, s));
+        goto done;
+    }
 
-    rc = clcache_get_buffer(&clcache, file->db, consumerRID, consumerRuv, supplierRuv);
-    if (rc != 0)
+    /* if this is part of ldif2cl - just write the entry without transaction */
+    if (s_cl5Desc.dbOpenMode == CL5_OPEN_LDIF2CL) {
+        rc = cldb->db->put(cldb->db, NULL, &key, data, 0);
+        if (rc != 0) {
+            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                          "_cl5WriteOperationTxn - Failed to write entry; db error - %d %s\n",
+                          rc, db_strerror(rc));
+            rc = CL5_DB_ERROR;
+        }
         goto done;
+    }
 
-    rc = clcache_load_buffer(clcache, &startCSN, continue_on_missing);
+    /* write the entry */
+    rc = EAGAIN;
+    cnt = 0;
 
-    if (rc == 0) {
-        haveChanges = PR_TRUE;
-        rc = CL5_SUCCESS;
-        if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-            csn_as_string(startCSN, PR_FALSE, csnStr);
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "%s: CSN %s found, position set for replay\n", agmt_name, csnStr);
+    while ((rc == EAGAIN || rc == DB_LOCK_DEADLOCK) && cnt < MAX_TRIALS) {
+        if (cnt != 0) {
+            /* abort previous transaction */
+            rc = TXN_ABORT(txnid);
+            if (rc != 0) {
+                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                              "_cl5WriteOperationTxn - Failed to abort transaction; db error - %d %s\n",
+                              rc, db_strerror(rc));
+                rc = CL5_DB_ERROR;
+                goto done;
+            }
+            /* back off */
+            interval = PR_MillisecondsToInterval(slapi_rand() % 100);
+            DS_Sleep(interval);
         }
-    } else if (rc == DB_NOTFOUND) {
-        /* buffer not loaded.
-         * either because no changes have to be sent ==> startCSN is NULL
-         * or the calculated startCSN cannot be found in the changelog
-         */
-        if (startCSN == NULL) {
-            rc = CL5_NOTFOUND;
+        /* begin transaction */
+        rc = TXN_BEGIN(s_cl5Desc.dbEnv, parent_txnid, &txnid, 0);
+        if (rc != 0) {
+            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                          "_cl5WriteOperationTxn - Failed to start transaction; db error - %d %s\n",
+                          rc, db_strerror(rc));
+            rc = CL5_DB_ERROR;
             goto done;
         }
-        /* check whether this csn should be present */
-        rc = _cl5CheckMissingCSN(startCSN, supplierRuv, file);
-        if (rc == CL5_MISSING_DATA) /* we should have had the change but we don't */
-        {
-            if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-                csn_as_string(startCSN, PR_FALSE, csnStr);
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "repl_plugin_name_cl - %s: CSN %s not found, seems to be missing\n", agmt_name, csnStr);
+
+        rc = cldb->db->put(cldb->db, txnid, &key, data, 0);
+        if (CL5_OS_ERR_IS_DISKFULL(rc)) {
+            slapi_log_err(SLAPI_LOG_CRIT, repl_plugin_name_cl,
+                          "_cl5WriteOperationTxn - Changelog (%s) DISK FULL; db error - %d %s\n",
+                          s_cl5Desc.dbDir, rc, db_strerror(rc));
+            rc = CL5_DB_ERROR;
+            goto done;
+        }
+        if (cnt != 0) {
+            if (rc == 0) {
+                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "_cl5WriteOperationTxn - "
+                                                                  "retry (%d) the transaction (csn=%s) succeeded\n",
+                              cnt, (char *)key.data);
+            } else if ((cnt + 1) >= MAX_TRIALS) {
+                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "_cl5WriteOperationTxn - "
+                                                                  "retry (%d) the transaction (csn=%s) failed (rc=%d (%s))\n",
+                              cnt, (char *)key.data, rc, db_strerror(rc));
             }
-        } else /* we are not as up to date or we purged */
-        {
-            csn_as_string(startCSN, PR_FALSE, csnStr);
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "repl_plugin_name_cl - %s: CSN %s not found, we aren't as up to date, or we purged\n",
-                          agmt_name, csnStr);
         }
+        cnt++;
+    }
+
+    if (rc == 0) /* we successfully added entry */
+    {
+        rc = TXN_COMMIT(txnid);
     } else {
-        csn_as_string(startCSN, PR_FALSE, csnStr);
-        /* db error */
+        char s[CSN_STRSIZE];
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "repl_plugin_name_cl - %s: Failed to retrieve change with CSN %s; db error - %d %s\n",
-                      agmt_name, csnStr, rc, db_strerror(rc));
-
+                      "_cl5WriteOperationTxn - Failed to write entry with csn (%s); "
+                      "db error - %d %s\n",
+                      csn_as_string(op->csn, PR_FALSE, s),
+                      rc, db_strerror(rc));
+        rc = TXN_ABORT(txnid);
+        if (rc != 0) {
+            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                          "_cl5WriteOperationTxn - Failed to abort transaction; db error - %d %s\n",
+                          rc, db_strerror(rc));
+        }
         rc = CL5_DB_ERROR;
+        goto done;
     }
 
+    /* update entry count - we assume that all entries are new */
+    PR_AtomicIncrement(&cldb->entryCount);
 
-    /* setup the iterator */
-    if (haveChanges) {
-        *iterator = (CL5ReplayIterator *)slapi_ch_calloc(1, sizeof(CL5ReplayIterator));
-
-        if (*iterator == NULL) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5PositionCursorForReplay - %s - Failed to allocate iterator\n", agmt_name);
-            rc = CL5_MEMORY_ERROR;
-            goto done;
-        }
-
-        /* ONREPL - should we make a copy of both RUVs here ?*/
-        (*iterator)->fileObj = fileObj;
-        (*iterator)->clcache = clcache;
-        clcache = NULL;
-        (*iterator)->consumerRID = consumerRID;
-        (*iterator)->consumerRuv = consumerRuv;
-        (*iterator)->supplierRuvObj = supplierRuvObj;
-    } else if (rc == CL5_SUCCESS) {
-        /* we have no changes to send */
-        rc = CL5_NOTFOUND;
-    }
+    /* update purge vector if we have not seen any changes from this replica before */
+    _cl5UpdateRUV(cldb, op->csn, PR_TRUE, PR_TRUE);
 
+    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                  "cl5WriteOperationTxn - Successfully written entry with csn (%s)\n", csnStr);
+    rc = CL5_SUCCESS;
 done:
-    if (clcache)
-        clcache_return_buffer(&clcache);
-
-    if (rc != CL5_SUCCESS) {
-        if (supplierRuvObj)
-            object_release(supplierRuvObj);
-    }
+    if (data->data)
+        slapi_ch_free(&(data->data));
+    slapi_ch_free((void **)&data);
 
     return rc;
 }
 
-struct ruv_it
-{
-    CSN **csns; /* csn list */
-    int alloc;  /* allocated size */
-    int pos;    /* position in the list */
-};
-
 static int
-ruv_consumer_iterator(const ruv_enum_data *enum_data, void *arg)
+_cl5WriteOperation(cldb_Handle *cldb, const slapi_operation_parameters *op)
 {
-    struct ruv_it *data = (struct ruv_it *)arg;
-
-    PR_ASSERT(data);
-
-    /* check if we have space for one more element */
-    if (data->pos >= data->alloc - 2) {
-        data->alloc += 4;
-        data->csns = (CSN **)slapi_ch_realloc((void *)data->csns, data->alloc * sizeof(CSN *));
-    }
-
-    data->csns[data->pos] = csn_dup(enum_data->csn);
-    data->pos++;
-
-    return 0;
+    return _cl5WriteOperationTxn(cldb, op, NULL);
 }
 
-
 static int
-ruv_supplier_iterator(const ruv_enum_data *enum_data, void *arg)
+_cl5GetFirstEntry(cldb_Handle *cldb, CL5Entry *entry, void **iterator, DB_TXN *txnid)
 {
-    int i;
-    PRBool found = PR_FALSE;
-    ReplicaId rid;
-    struct ruv_it *data = (struct ruv_it *)arg;
-
-    PR_ASSERT(data);
+    int rc;
+    DBC *cursor = NULL;
+    DBT key = {0}, data = {0};
+    CL5Iterator *it;
 
-    rid = csn_get_replicaid(enum_data->min_csn);
-    /* check if the replica that generated the csn is already in the list */
-    for (i = 0; i < data->pos; i++) {
-        if (rid == csn_get_replicaid(data->csns[i])) {
-            found = PR_TRUE;
+    PR_ASSERT(entry && iterator);
 
-            /* remove datacsn[i] if it is greater or equal to the supplier's maxcsn */
-            if (csn_compare(data->csns[i], enum_data->csn) >= 0) {
-                int j;
+    /* create cursor */
+    rc = cldb->db->cursor(cldb->db, txnid, &cursor, 0);
+    if (rc != 0) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "_cl5GetFirstEntry - Failed to create cursor; db error - %d %s\n", rc, db_strerror(rc));
+        rc = CL5_DB_ERROR;
+        goto done;
+    }
 
-                csn_free(&data->csns[i]);
-                for (j = i + 1; j < data->pos; j++) {
-                    data->csns[j - 1] = data->csns[j];
-                }
-                data->pos--;
-            }
-            break;
+    key.flags = DB_DBT_MALLOC;
+    data.flags = DB_DBT_MALLOC;
+    while ((rc = cursor->c_get(cursor, &key, &data, DB_NEXT)) == 0) {
+        /* skip service entries */
+        if (cl5HelperEntry((char *)key.data, NULL)) {
+            slapi_ch_free(&(key.data));
+            slapi_ch_free(&(data.data));
+            continue;
         }
-    }
 
-    if (!found) {
-        /* check if we have space for one more element */
-        if (data->pos >= data->alloc - 2) {
-            data->alloc += 4;
-            data->csns = (CSN **)slapi_ch_realloc((void *)data->csns,
-                                                  data->alloc * sizeof(CSN *));
+        /* format entry */
+        slapi_ch_free(&(key.data));
+        rc = cl5DBData2Entry(data.data, data.size, entry, cldb->clcrypt_handle);
+        slapi_ch_free(&(data.data));
+        if (rc != 0) {
+            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                          "_cl5GetFirstOperation - Failed to format entry: %d\n", rc);
+            goto done;
         }
 
-        data->csns[data->pos] = csn_dup(enum_data->min_csn);
-        data->pos++;
+        it = (CL5Iterator *)slapi_ch_malloc(sizeof(CL5Iterator));
+        it->cursor = cursor;
+        it->it_cldb = cldb;
+        *(CL5Iterator **)iterator = it;
+
+        return CL5_SUCCESS;
+    }
+    /*
+     * Bug 430172 - memory leaks after db "get" deadlocks, e.g. in CL5 trim
+     * Even when db->c_get() does not return success, memory may have been
+     * allocated in the DBT.  This seems to happen when DB_DBT_MALLOC was set,
+     * the data being retrieved is larger than the page size, and we got
+     * DB_LOCK_DEADLOCK. libdb allocates the memory and then finds itself
+     * deadlocked trying to go through the overflow page list.  It returns
+     * DB_LOCK_DEADLOCK which we've assumed meant that no memory was allocated
+     * for the DBT.
+     *
+     * The following slapi_ch_free frees the memory only when the value is
+     * non NULL, which is true if the situation described above occurs.
+     */
+    slapi_ch_free((void **)&key.data);
+    slapi_ch_free((void **)&data.data);
+
+    /* walked of the end of the file */
+    if (rc == DB_NOTFOUND) {
+        rc = CL5_NOTFOUND;
+        goto done;
     }
-    return 0;
-}
 
+    /* db error occured while iterating */
+    /* On this path, the condition "rc != 0" cannot be false */
+    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                  "_cl5GetFirstEntry - Failed to get entry; db error - %d %s\n",
+                  rc, db_strerror(rc));
+    rc = CL5_DB_ERROR;
 
-static int
-my_csn_compare(const void *arg1, const void *arg2)
-{
-    return (csn_compare(*((CSN **)arg1), *((CSN **)arg2)));
-}
+done:
+    /* error occured */
+    /* We didn't success in assigning this cursor to the iterator,
+     * so we need to free the cursor here */
+    if (cursor)
+        cursor->c_close(cursor);
 
+    return rc;
+}
 
-/* builds CSN ordered list of all csns in the RUV */
-CSN **
-cl5BuildCSNList(const RUV *consRuv, const RUV *supRuv)
+static int
+_cl5GetNextEntry(CL5Entry *entry, void *iterator)
 {
-    struct ruv_it data;
-    int count, rc;
-    CSN **csns;
+    int rc;
+    CL5Iterator *it;
+    DBT key = {0}, data = {0};
 
-    PR_ASSERT(consRuv);
+    PR_ASSERT(entry && iterator);
 
-    count = ruv_replica_count(consRuv);
-    csns = (CSN **)slapi_ch_calloc(count + 1, sizeof(CSN *));
+    it = (CL5Iterator *)iterator;
 
-    data.csns = csns;
-    data.alloc = count + 1;
-    data.pos = 0;
+    key.flags = DB_DBT_MALLOC;
+    data.flags = DB_DBT_MALLOC;
+    while ((rc = it->cursor->c_get(it->cursor, &key, &data, DB_NEXT)) == 0) {
+        if (cl5HelperEntry((char *)key.data, NULL)) {
+            slapi_ch_free(&(key.data));
+            slapi_ch_free(&(data.data));
+            continue;
+        }
 
-    /* add consumer elements to the list */
-    rc = ruv_enumerate_elements(consRuv, ruv_consumer_iterator, &data);
-    if (rc == 0 && supRuv) {
-        /* add supplier elements to the list */
-        rc = ruv_enumerate_elements(supRuv, ruv_supplier_iterator, &data);
+        slapi_ch_free(&(key.data));
+        /* format entry */
+        rc = cl5DBData2Entry(data.data, data.size, entry, it->it_cldb->clcrypt_handle);
+        slapi_ch_free(&(data.data));
+        if (rc != 0) {
+            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                          "_cl5GetNextEntry - Failed to format entry: %d\n", rc);
+        }
+
+        return rc;
     }
+    /*
+     * Bug 430172 - memory leaks after db "get" deadlocks, e.g. in CL5 trim
+     * Even when db->c_get() does not return success, memory may have been
+     * allocated in the DBT.  This seems to happen when DB_DBT_MALLOC was set,
+     * the data being retrieved is larger than the page size, and we got
+     * DB_LOCK_DEADLOCK. libdb allocates the memory and then finds itself
+     * deadlocked trying to go through the overflow page list.  It returns
+     * DB_LOCK_DEADLOCK which we've assumed meant that no memory was allocated
+     * for the DBT.
+     *
+     * The following slapi_ch_free frees the memory only when the value is
+     * non NULL, which is true if the situation described above occurs.
+     */
+    slapi_ch_free((void **)&key.data);
+    slapi_ch_free((void **)&data.data);
 
-    /* we have no csns */
-    if (data.csns[0] == NULL) {
-        /* csns might have been realloced in ruv_supplier_iterator() */
-        slapi_ch_free((void **)&data.csns);
-        csns = NULL;
-    } else {
-        csns = data.csns;
-        data.csns[data.pos] = NULL;
-        if (rc == 0) {
-            qsort(csns, data.pos, sizeof(CSN *), my_csn_compare);
-        } else {
-            cl5DestroyCSNList(&csns);
-        }
+    /* walked of the end of the file or entry is out of range */
+    if (rc == 0 || rc == DB_NOTFOUND) {
+        return CL5_NOTFOUND;
     }
 
-    return csns;
+    /* cursor operation failed */
+    slapi_log_err(rc == CL5_DB_LOCK_ERROR ? SLAPI_LOG_REPL : SLAPI_LOG_ERR,
+                  repl_plugin_name_cl,
+                  "_cl5GetNextEntry - Failed to get entry; db error - %d %s\n",
+                  rc, db_strerror(rc));
+
+    return rc;
 }
 
-void
-cl5DestroyCSNList(CSN ***csns)
+static int
+_cl5CurrentDeleteEntry(void *iterator)
 {
-    if (csns && *csns) {
-        int i;
+    int rc;
+    CL5Iterator *it;
+    cldb_Handle *cldb;
 
-        for (i = 0; (*csns)[i]; i++) {
-            csn_free(&(*csns)[i]);
-        }
+    PR_ASSERT(iterator);
 
-        slapi_ch_free((void **)csns);
+    it = (CL5Iterator *)iterator;
+
+    rc = it->cursor->c_del(it->cursor, 0);
+
+    if (rc == 0) {
+        /* decrement entry count */
+        cldb = it->it_cldb;
+        PR_AtomicDecrement(&cldb->entryCount);
+        return CL5_SUCCESS;
+    } else {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "_cl5CurrentDeleteEntry - Failed, err=%d %s\n",
+                      rc, db_strerror(rc));
+        /*
+         * We don't free(close) the cursor here, as the caller will free it by
+         * a call to cl5DestroyIterator.  Freeing it here is a potential bug,
+         * as the cursor can't be referenced later once freed.
+         */
+        return rc;
     }
 }
 
-/* A csn should be in the changelog if it is larger than purge vector csn for the same
-   replica and is smaller than the csn in supplier's ruv for the same replica.
-   The functions returns
-        CL5_PURGED      if data was purged from the changelog or was never logged
-                        because it was loaded as part of replica initialization
-        CL5_MISSING     if the data erouneously missing
-        CL5_SUCCESS     if that has not and should not been seen by the server
- */
-static int
-_cl5CheckMissingCSN(const CSN *csn, const RUV *supplierRuv, CL5DBFile *file)
+PRBool
+cl5HelperEntry(const char *csnstr, CSN *csnp)
 {
-    ReplicaId rid;
-    CSN *supplierCsn = NULL;
-    CSN *purgeCsn = NULL;
-    int rc = CL5_SUCCESS;
-    char csnStr[CSN_STRSIZE];
-
-    PR_ASSERT(csn && supplierRuv && file);
+    CSN *csn;
+    time_t csnTime;
+    PRBool retval = PR_FALSE;
 
-    rid = csn_get_replicaid(csn);
-    ruv_get_largest_csn_for_replica(supplierRuv, rid, &supplierCsn);
-    if (supplierCsn == NULL) {
-        /* we have not seen any changes from this replica so it is
-           ok not to have this csn */
-        if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
-                                                               "can't locate %s csn: we have not seen any changes for replica %d\n",
-                          csn_as_string(csn, PR_FALSE, csnStr), rid);
-        }
-        return CL5_SUCCESS;
+    if (csnp) {
+        csn = csnp;
+    } else {
+        csn = csn_new_by_string(csnstr);
     }
-
-    ruv_get_largest_csn_for_replica(file->purgeRUV, rid, &purgeCsn);
-    if (purgeCsn == NULL) {
-        /* changelog never contained any changes for this replica */
-        if (csn_compare(csn, supplierCsn) <= 0) {
-            if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
-                                                                   "the change with %s csn was never logged because it was imported "
-                                                                   "during replica initialization\n",
-                              csn_as_string(csn, PR_FALSE, csnStr));
-            }
-            rc = CL5_PURGED_DATA; /* XXXggood is that the correct return value? */
-        } else {
-            if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
-                                                                   "change with %s csn has not yet been seen by this server; "
-                                                                   " last csn seen from that replica is %s\n",
-                              csn_as_string(csn, PR_FALSE, csnStr),
-                              csn_as_string(supplierCsn, PR_FALSE, csnStr));
-            }
-            rc = CL5_SUCCESS;
-        }
-    } else /* we have both purge and supplier csn */
-    {
-        if (csn_compare(csn, purgeCsn) < 0) /* the csn is below the purge point */
-        {
-            rc = CL5_PURGED_DATA;
-        } else {
-            if (csn_compare(csn, supplierCsn) <= 0) /* we should have the data but we don't */
-            {
-                if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-                    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
-                                                                       "change with %s csn has been purged by this server; "
-                                                                       "the current purge point for that replica is %s\n",
-                                  csn_as_string(csn, PR_FALSE, csnStr),
-                                  csn_as_string(purgeCsn, PR_FALSE, csnStr));
-                }
-                rc = CL5_MISSING_DATA;
-            } else {
-                if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
-                    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
-                                                                       "change with %s csn has not yet been seen by this server; "
-                                                                       " last csn seen from that replica is %s\n",
-                                  csn_as_string(csn, PR_FALSE, csnStr),
-                                  csn_as_string(supplierCsn, PR_FALSE, csnStr));
-                }
-                rc = CL5_SUCCESS;
-            }
-        }
+    if (csn == NULL) {
+        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                      "cl5HelperEntry - Failed to get csn time; csn error\n");
+        return PR_FALSE;
     }
+    csnTime = csn_get_time(csn);
 
-    if (supplierCsn)
-        csn_free(&supplierCsn);
-
-    if (purgeCsn)
-        csn_free(&purgeCsn);
+    if (csnTime == ENTRY_COUNT_TIME || csnTime == PURGE_RUV_TIME) {
+        retval = PR_TRUE;
+    }
 
-    return rc;
+    if (NULL == csnp)
+        csn_free(&csn);
+    return retval;
 }
 
-/* Helper functions that work with individual changelog files */
-
-/* file name format : <replica name>_<replica generation>db{2,3,...} */
+#ifdef FOR_DEBUGGING
+/* Replay iteration helper functions */
 static PRBool
-_cl5FileName2Replica(const char *file_name, Replica **replica)
+_cl5ValidReplayIterator(const CL5ReplayIterator *iterator)
 {
-    char *repl_name, *file_gen, *repl_gen;
-    int len;
-
-    PR_ASSERT(file_name && replica);
-
-    *replica = NULL;
-
-    /* this is database file */
-    if (_cl5FileEndsWith(file_name, DB_EXTENSION) ||
-        _cl5FileEndsWith(file_name, DB_EXTENSION_DB4) ||
-        _cl5FileEndsWith(file_name, DB_EXTENSION_DB3)) {
-        repl_name = slapi_ch_strdup(file_name);
-        file_gen = strstr(repl_name, FILE_SEP);
-        if (file_gen) {
-            int extlen = strlen(DB_EXTENSION);
-            *file_gen = '\0';
-            file_gen += strlen(FILE_SEP);
-            len = strlen(file_gen);
-            if (len <= extlen + 1) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "_cl5FileName2Replica - "
-                              "Invalid file name (%s)\n",
-                              file_name);
-            } else {
-                /* get rid of the file extension */
-                file_gen[len - extlen - 1] = '\0';
-                *replica = replica_get_by_name(repl_name);
-                if (*replica) {
-                    repl_gen = replica_get_generation(*replica);
-                    PR_ASSERT(repl_gen);
-                    if (strcmp(file_gen, repl_gen) != 0) {
-                        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                                      "_cl5FileName2Replica - "
-                                      "Replica generation mismatch for replica at (%s), "
-                                      "file generation %s, new replica generation %s\n",
-                                      slapi_sdn_get_dn(replica_get_root(*replica)), file_gen, repl_gen);
-
-                        *replica = NULL;
-                    }
-                    slapi_ch_free((void **)&repl_gen);
-                }
-            }
-            slapi_ch_free((void **)&repl_name);
-        } else {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5FileName2Replica - "
-                                                               "Malformed file name - %s\n",
-                          file_name);
-        }
-
-        return PR_TRUE;
-    } else
+    if (iterator == NULL ||
+        iterator->consumerRuv == NULL || iterator->supplierRuvObj == NULL ||
+        iterator->it_cldb == NULL)
         return PR_FALSE;
+
+    return PR_TRUE;
 }
+#endif
 
-/* file name format : <replica name>_<replica generation>db{2,3} */
-static char *
-_cl5Replica2FileName(Replica *r)
+/* Algorithm: ONREPL!!!
+ */
+struct replica_hash_entry
 {
-    const char *replName;
-    char *replGen, *fileName;
-
-    PR_ASSERT(r);
+    ReplicaId rid;      /* replica id */
+    PRBool sendChanges; /* indicates whether changes should be sent for this replica */
+};
 
-    replName = replica_get_name(r);
-    replGen = replica_get_generation(r);
 
-    fileName = _cl5MakeFileName(replName, replGen);
+static int
+_cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Replica *replica, CL5ReplayIterator **iterator, int *continue_on_missing)
+{
+    CLC_Buffer *clcache = NULL;
+    CSN *startCSN = NULL;
+    char csnStr[CSN_STRSIZE];
+    int rc = CL5_SUCCESS;
+    Object *supplierRuvObj = NULL;
+    RUV *supplierRuv = NULL;
+    PRBool haveChanges = PR_FALSE;
+    char *agmt_name;
 
-    slapi_ch_free((void **)&replGen);
+    cldb_Handle *cldb = replica_get_file_info(replica);
+    PR_ASSERT (consumerRuv && replica && iterator);
+ 
+    csnStr[0] = '\0';
 
-    return fileName;
-}
+    /* get supplier's RUV */
+    supplierRuvObj = replica_get_ruv(replica);
+    PR_ASSERT(supplierRuvObj);
 
-static char *
-_cl5MakeFileName(const char *replName, const char *replGen)
-{
-    char *fileName = slapi_ch_smprintf("%s/%s%s%s.%s",
-                                       s_cl5Desc.dbDir, replName,
-                                       FILE_SEP, replGen, DB_EXTENSION);
+    if (!supplierRuvObj) {
+        rc = CL5_UNKNOWN_ERROR;
+        goto done;
+    }
 
-    return fileName;
-}
+    supplierRuv = (RUV *)object_get_data(supplierRuvObj);
+    PR_ASSERT(supplierRuv);
 
-/* open file that corresponds to a particular database */
-static int
-_cl5DBOpenFile(Replica *replica, Object **obj, PRBool checkDups)
-{
-    int rc;
-    const char *replName;
-    char *replGen;
+    agmt_name = get_thread_private_agmtname();
 
-    PR_ASSERT(replica);
+    if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
+        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5PositionCursorForReplay - (%s): Consumer RUV:\n", agmt_name);
+        ruv_dump(consumerRuv, agmt_name, NULL);
+        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5PositionCursorForReplay - (%s): Supplier RUV:\n", agmt_name);
+        ruv_dump(supplierRuv, agmt_name, NULL);
+    }
 
-    replName = replica_get_name(replica);
-    PR_ASSERT(replName);
-    replGen = replica_get_generation(replica);
-    PR_ASSERT(replGen);
 
-    rc = _cl5DBOpenFileByReplicaName(replName, replGen, obj, checkDups);
+    /* initialize the changelog buffer and do the initial load */
 
-    slapi_ch_free((void **)&replGen);
+    rc = clcache_get_buffer(&clcache, cldb->db, consumerRID, consumerRuv, supplierRuv);
+    if (rc != 0)
+        goto done;
 
-    return rc;
-}
+    rc = clcache_load_buffer(clcache, &startCSN, continue_on_missing);
 
-static int
-_cl5DBOpenFileByReplicaName(const char *replName, const char *replGen, Object **obj, PRBool checkDups)
-{
-    int rc = CL5_SUCCESS;
-    Object *tmpObj;
-    CL5DBFile *file;
-    char *file_name;
-
-    PR_ASSERT(replName && replGen);
-
-    if (checkDups) {
-        PR_Lock(s_cl5Desc.fileLock);
-        file_name = _cl5MakeFileName(replName, replGen);
-        tmpObj = objset_find(s_cl5Desc.dbFiles, _cl5CompareDBFile, file_name);
-        slapi_ch_free((void **)&file_name);
-        if (tmpObj) /* this file already exist */
-        {
+    if (rc == 0) {
+        haveChanges = PR_TRUE;
+        rc = CL5_SUCCESS;
+        if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
+            csn_as_string(startCSN, PR_FALSE, csnStr);
             slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5DBOpenFileByReplicaName - Found DB object %p for replica %s\n", tmpObj, replName);
-            /* if we were asked for file handle - keep the handle */
-            if (obj) {
-                *obj = tmpObj;
-            } else {
-                object_release(tmpObj);
-            }
-
-            rc = CL5_SUCCESS;
+                          "%s: CSN %s found, position set for replay\n", agmt_name, csnStr);
+        }
+    } else if (rc == DB_NOTFOUND) {
+        /* buffer not loaded.
+         * either because no changes have to be sent ==> startCSN is NULL
+         * or the calculated startCSN cannot be found in the changelog
+         */
+        if (startCSN == NULL) {
+            rc = CL5_NOTFOUND;
             goto done;
         }
-    }
-
-    rc = _cl5NewDBFile(replName, replGen, &file);
-    if (rc == CL5_SUCCESS) {
-        /* This creates the file but doesn't set the init flag
-         * The flag is set later when the purge and max ruvs are set.
-         * This is to prevent some thread to get file access before the
-         * structure is fully initialized */
-        rc = _cl5AddDBFile(file, &tmpObj);
-        if (rc == CL5_SUCCESS) {
-            /* read purge RUV - done here because it needs file object rather than file pointer */
-            rc = _cl5ReadRUV(replGen, tmpObj, PR_TRUE);
-            if (rc != CL5_SUCCESS) {
+        /* check whether this csn should be present */
+        rc = _cl5CheckMissingCSN(startCSN, supplierRuv, cldb);
+        if (rc == CL5_MISSING_DATA) /* we should have had the change but we don't */
+        {
+            if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
+                csn_as_string(startCSN, PR_FALSE, csnStr);
                 slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "_cl5DBOpenFileByReplicaName - Failed to get purge RUV\n");
-                goto done;
+                              "repl_plugin_name_cl - %s: CSN %s not found, seems to be missing\n", agmt_name, csnStr);
             }
+        } else /* we are not as up to date or we purged */
+        {
+            csn_as_string(startCSN, PR_FALSE, csnStr);
+            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                          "repl_plugin_name_cl - %s: CSN %s not found, we aren't as up to date, or we purged\n",
+                          agmt_name, csnStr);
+        }
+    } else {
+        csn_as_string(startCSN, PR_FALSE, csnStr);
+        /* db error */
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "repl_plugin_name_cl - %s: Failed to retrieve change with CSN %s; db error - %d %s\n",
+                      agmt_name, csnStr, rc, db_strerror(rc));
 
-            /* read ruv that represents the upper bound of the changes stored in the file */
-            rc = _cl5ReadRUV(replGen, tmpObj, PR_FALSE);
-            if (rc != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "_cl5DBOpenFileByReplicaName - Failed to get upper bound RUV\n");
-                goto done;
-            }
+        rc = CL5_DB_ERROR;
+    }
 
-            /* Mark the DB File initialize */
-            _cl5DBFileInitialized(tmpObj);
 
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5DBOpenFileByReplicaName - Created new DB object %p\n", tmpObj);
-            if (obj) {
-                *obj = tmpObj;
-            } else {
-                object_release(tmpObj);
-            }
+    /* setup the iterator */
+    if (haveChanges) {
+        *iterator = (CL5ReplayIterator *)slapi_ch_calloc(1, sizeof(CL5ReplayIterator));
+
+        if (*iterator == NULL) {
+            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                          "_cl5PositionCursorForReplay - %s - Failed to allocate iterator\n", agmt_name);
+            rc = CL5_MEMORY_ERROR;
+            goto done;
         }
-    }
 
-done:;
-    if (rc != CL5_SUCCESS) {
-        if (file)
-            _cl5DBCloseFile((void **)&file);
+        /* ONREPL - should we make a copy of both RUVs here ?*/
+        (*iterator)->it_cldb = cldb;
+        (*iterator)->clcache = clcache;
+        clcache = NULL;
+        (*iterator)->consumerRID = consumerRID;
+        (*iterator)->consumerRuv = consumerRuv;
+        (*iterator)->supplierRuvObj = supplierRuvObj;
+    } else if (rc == CL5_SUCCESS) {
+        /* we have no changes to send */
+        rc = CL5_NOTFOUND;
     }
 
-    if (checkDups) {
-        PR_Unlock(s_cl5Desc.fileLock);
+done:
+    if (clcache)
+        clcache_return_buffer(&clcache);
+
+    if (rc != CL5_SUCCESS) {
+        if (supplierRuvObj)
+            object_release(supplierRuvObj);
     }
 
     return rc;
 }
 
-/* adds file to the db file list */
+struct ruv_it
+{
+    CSN **csns; /* csn list */
+    int alloc;  /* allocated size */
+    int pos;    /* position in the list */
+};
+
 static int
-_cl5AddDBFile(CL5DBFile *file, Object **obj)
+ruv_consumer_iterator(const ruv_enum_data *enum_data, void *arg)
 {
-    int rc;
-    Object *tmpObj;
+    struct ruv_it *data = (struct ruv_it *)arg;
 
-    PR_ASSERT(file);
+    PR_ASSERT(data);
 
-    tmpObj = object_new(file, _cl5DBCloseFile);
-    rc = objset_add_obj(s_cl5Desc.dbFiles, tmpObj);
-    if (rc != OBJSET_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5AddDBFile - Failed to add db file to the list; "
-                      "repl_objset error - %d\n",
-                      rc);
-        object_release(tmpObj);
-        return CL5_OBJSET_ERROR;
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5AddDBFile - Added new DB object %p\n", tmpObj);
+    /* check if we have space for one more element */
+    if (data->pos >= data->alloc - 2) {
+        data->alloc += 4;
+        data->csns = (CSN **)slapi_ch_realloc((void *)data->csns, data->alloc * sizeof(CSN *));
     }
 
-    if (obj) {
-        *obj = tmpObj;
-    } else
-        object_release(tmpObj);
+    data->csns[data->pos] = csn_dup(enum_data->csn);
+    data->pos++;
 
-    return CL5_SUCCESS;
+    return 0;
 }
 
+
 static int
-_cl5NewDBFile(const char *replName, const char *replGen, CL5DBFile **dbFile)
+ruv_supplier_iterator(const ruv_enum_data *enum_data, void *arg)
 {
-    int rc;
-    DB *db = NULL;
-    char *name;
-#ifdef HPUX
-    char cwd[PATH_MAX + 1];
-#endif
-
-    PR_ASSERT(replName && replGen && dbFile);
-
-    if (!dbFile) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5NewDBFile - NULL dbFile\n");
-        return CL5_UNKNOWN_ERROR;
-    }
-
-    (*dbFile) = (CL5DBFile *)slapi_ch_calloc(1, sizeof(CL5DBFile));
-    if (*dbFile == NULL) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5NewDBFile - memory allocation failed\n");
-        return CL5_MEMORY_ERROR;
-    }
+    int i;
+    PRBool found = PR_FALSE;
+    ReplicaId rid;
+    struct ruv_it *data = (struct ruv_it *)arg;
 
-    name = _cl5MakeFileName(replName, replGen);
-    {
-        /* The subname argument allows applications to have
-     * subdatabases, i.e., multiple databases inside of a single
-     * physical file. This is useful when the logical databases
-     * are both numerous and reasonably small, in order to
-     * avoid creating a large number of underlying files.
-     */
-        char *subname = NULL;
-        DB_ENV *dbEnv = s_cl5Desc.dbEnv;
+    PR_ASSERT(data);
 
-        rc = db_create(&db, dbEnv, 0);
-        if (0 != rc) {
-            goto out;
-        }
+    rid = csn_get_replicaid(enum_data->min_csn);
+    /* check if the replica that generated the csn is already in the list */
+    for (i = 0; i < data->pos; i++) {
+        if (rid == csn_get_replicaid(data->csns[i])) {
+            found = PR_TRUE;
 
-        rc = db->set_pagesize(
-            db,
-            s_cl5Desc.dbConfig.pageSize);
+            /* remove datacsn[i] if it is greater or equal to the supplier's maxcsn */
+            if (csn_compare(data->csns[i], enum_data->csn) >= 0) {
+                int j;
 
-        if (0 != rc) {
-            goto out;
+                csn_free(&data->csns[i]);
+                for (j = i + 1; j < data->pos; j++) {
+                    data->csns[j - 1] = data->csns[j];
+                }
+                data->pos--;
+            }
+            break;
         }
-
-        DB_OPEN(s_cl5Desc.dbEnvOpenFlags,
-                db, NULL /* txnid */, name, subname, DB_BTREE,
-                DB_CREATE | DB_THREAD, s_cl5Desc.dbConfig.fileMode, rc);
-    }
-out:
-    if (rc != 0) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5NewDBFile - db_open failed; db error - %d %s\n",
-                      rc, db_strerror(rc));
-        rc = CL5_DB_ERROR;
-        goto done;
     }
 
-    (*dbFile)->db = db;
-    (*dbFile)->name = name;
-    name = NULL; /* transfer ownership to dbFile struct */
-    (*dbFile)->replName = slapi_ch_strdup(replName);
-    (*dbFile)->replGen = slapi_ch_strdup(replGen);
-
-
-    /* compute number of entries in the file */
-    /* ONREPL - to improve performance, we keep entry count in memory
-                and write it down during shutdown. Problem: this will not
-                work with multiple processes. Do we have to worry about that?
-     */
-    if (s_cl5Desc.dbOpenMode == CL5_OPEN_NORMAL) {
-        rc = _cl5GetEntryCount(*dbFile);
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5NewDBFile - Failed to get entry count\n");
-            goto done;
+    if (!found) {
+        /* check if we have space for one more element */
+        if (data->pos >= data->alloc - 2) {
+            data->alloc += 4;
+            data->csns = (CSN **)slapi_ch_realloc((void *)data->csns,
+                                                  data->alloc * sizeof(CSN *));
         }
-    }
-
-done:
-    if (rc != CL5_SUCCESS) {
-        _cl5DBCloseFile((void **)dbFile);
-        /* slapi_ch_free accepts NULL pointer */
-        slapi_ch_free((void **)&name);
 
-        slapi_ch_free((void **)dbFile);
+        data->csns[data->pos] = csn_dup(enum_data->min_csn);
+        data->pos++;
     }
-
-    return rc;
+    return 0;
 }
 
-static void
-_cl5DBCloseFile(void **data)
+
+static int
+my_csn_compare(const void *arg1, const void *arg2)
 {
-    CL5DBFile *file;
-    int rc = 0;
+    return (csn_compare(*((CSN **)arg1), *((CSN **)arg2)));
+}
 
-    PR_ASSERT(data);
 
-    file = *(CL5DBFile **)data;
+/* builds CSN ordered list of all csns in the RUV */
+CSN **
+cl5BuildCSNList(const RUV *consRuv, const RUV *supRuv)
+{
+    struct ruv_it data;
+    int count, rc;
+    CSN **csns;
+
+    PR_ASSERT(consRuv);
 
-    PR_ASSERT(file);
+    count = ruv_replica_count(consRuv);
+    csns = (CSN **)slapi_ch_calloc(count + 1, sizeof(CSN *));
 
-    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBCloseFile - "
-                                                       "Closing database %s\n",
-                  file->name);
+    data.csns = csns;
+    data.alloc = count + 1;
+    data.pos = 0;
 
-    /* close the file */
-    /* if this is normal close or close after import, update entry count */
-    if ((s_cl5Desc.dbOpenMode == CL5_OPEN_NORMAL && s_cl5Desc.dbState == CL5_STATE_CLOSING) ||
-        s_cl5Desc.dbOpenMode == CL5_OPEN_LDIF2CL) {
-        _cl5WriteEntryCount(file);
-        _cl5WriteRUV(file, PR_TRUE);
-        _cl5WriteRUV(file, PR_FALSE);
+    /* add consumer elements to the list */
+    rc = ruv_enumerate_elements(consRuv, ruv_consumer_iterator, &data);
+    if (rc == 0 && supRuv) {
+        /* add supplier elements to the list */
+        rc = ruv_enumerate_elements(supRuv, ruv_supplier_iterator, &data);
     }
 
-    /* close the db */
-    if (file->db) {
-        rc = file->db->close(file->db, 0);
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5DBCloseFile - "
-                      "Closed the changelog database handle for %s "
-                      "(rc: %d)\n",
-                      file->name, rc);
-        file->db = NULL;
-    }
-
-    if (file->flags & DB_FILE_DELETED) {
-        /* We need to use the libdb API to delete the files, otherwise we'll
-         * run into problems when we try to checkpoint transactions later. */
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBCloseFile - "
-                                                           "removing the changelog %s (flag %d)\n",
-                      file->name, DEFAULT_DB_ENV_OP_FLAGS);
-        rc = s_cl5Desc.dbEnv->dbremove(s_cl5Desc.dbEnv, 0, file->name, 0,
-                                       DEFAULT_DB_ENV_OP_FLAGS);
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBCloseFile - "
-                                                               "failed to remove (%s) file; libdb error - %d (%s)\n",
-                          file->name, rc, db_strerror(rc));
+    /* we have no csns */
+    if (data.csns[0] == NULL) {
+        /* csns might have been realloced in ruv_supplier_iterator() */
+        slapi_ch_free((void **)&data.csns);
+        csns = NULL;
+    } else {
+        csns = data.csns;
+        data.csns[data.pos] = NULL;
+        if (rc == 0) {
+            qsort(csns, data.pos, sizeof(CSN *), my_csn_compare);
         } else {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBCloseFile - "
-                                                               "Deleted the changelog database file %s\n",
-                          file->name);
+            cl5DestroyCSNList(&csns);
         }
     }
 
-    /* slapi_ch_free accepts NULL pointer */
-    slapi_ch_free((void **)&file->name);
-    slapi_ch_free((void **)&file->replName);
-    slapi_ch_free((void **)&file->replGen);
-    ruv_destroy(&file->maxRUV);
-    ruv_destroy(&file->purgeRUV);
-    file->db = NULL;
-
-    slapi_ch_free(data);
+    return csns;
 }
 
-static int
-_cl5GetDBFile(Replica *replica, Object **obj)
+void
+cl5DestroyCSNList(CSN ***csns)
 {
-    char *fileName;
-
-    PR_ASSERT(replica && obj);
+    if (csns && *csns) {
+        int i;
 
-    fileName = _cl5Replica2FileName(replica);
+        for (i = 0; (*csns)[i]; i++) {
+            csn_free(&(*csns)[i]);
+        }
 
-    *obj = objset_find(s_cl5Desc.dbFiles, _cl5CompareDBFile, fileName);
-    if (*obj) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5GetDBFile - "
-                                                           "found DB object %p for database %s\n",
-                      *obj, fileName);
-        slapi_ch_free_string(&fileName);
-        return CL5_SUCCESS;
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5GetDBFile - "
-                                                           "no DB object found for database %s\n",
-                      fileName);
-        slapi_ch_free_string(&fileName);
-        return CL5_NOTFOUND;
+        slapi_ch_free((void **)csns);
     }
 }
 
+/* A csn should be in the changelog if it is larger than purge vector csn for the same
+   replica and is smaller than the csn in supplier's ruv for the same replica.
+   The functions returns
+        CL5_PURGED      if data was purged from the changelog or was never logged
+                        because it was loaded as part of replica initialization
+        CL5_MISSING     if the data erouneously missing
+        CL5_SUCCESS     if that has not and should not been seen by the server
+ */
 static int
-_cl5GetDBFileByReplicaName(const char *replName, const char *replGen, Object **obj)
+_cl5CheckMissingCSN(const CSN *csn, const RUV *supplierRuv, cldb_Handle *cldb)
 {
-    char *fileName;
-
-    PR_ASSERT(replName && replGen && obj);
+    ReplicaId rid;
+    CSN *supplierCsn = NULL;
+    CSN *purgeCsn = NULL;
+    int rc = CL5_SUCCESS;
+    char csnStr[CSN_STRSIZE];
 
-    fileName = _cl5MakeFileName(replName, replGen);
+    PR_ASSERT(csn && supplierRuv && cldb);
 
-    *obj = objset_find(s_cl5Desc.dbFiles, _cl5CompareDBFile, fileName);
-    if (*obj) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5GetDBFileByReplicaName - "
-                                                           "found DB object %p for database %s\n",
-                      *obj, fileName);
-        slapi_ch_free_string(&fileName);
+    rid = csn_get_replicaid(csn);
+    ruv_get_largest_csn_for_replica(supplierRuv, rid, &supplierCsn);
+    if (supplierCsn == NULL) {
+        /* we have not seen any changes from this replica so it is
+           ok not to have this csn */
+        if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
+            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
+                                                               "can't locate %s csn: we have not seen any changes for replica %d\n",
+                          csn_as_string(csn, PR_FALSE, csnStr), rid);
+        }
         return CL5_SUCCESS;
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5GetDBFileByReplicaName - "
-                                                           "no DB object found for database %s\n",
-                      fileName);
-        slapi_ch_free_string(&fileName);
-        return CL5_NOTFOUND;
     }
-}
-
-static void
-_cl5DBDeleteFile(Object *file_obj)
-{
-    CL5DBFile *file;
-    int rc = 0;
 
-    PR_ASSERT(file_obj);
-
-    file = (CL5DBFile *)object_get_data(file_obj);
-    PR_ASSERT(file);
-    file->flags |= DB_FILE_DELETED;
-    rc = objset_remove_obj(s_cl5Desc.dbFiles, file_obj);
-    if (rc != OBJSET_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBDeleteFile - "
-                                                           "could not find DB object %p\n",
-                      file_obj);
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBDeleteFile - "
-                                                           "removed DB object %p\n",
-                      file_obj);
+    ruv_get_largest_csn_for_replica(cldb->purgeRUV, rid, &purgeCsn);
+    if (purgeCsn == NULL) {
+        /* changelog never contained any changes for this replica */
+        if (csn_compare(csn, supplierCsn) <= 0) {
+            if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
+                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
+                                                                   "the change with %s csn was never logged because it was imported "
+                                                                   "during replica initialization\n",
+                              csn_as_string(csn, PR_FALSE, csnStr));
+            }
+            rc = CL5_PURGED_DATA; /* XXXggood is that the correct return value? */
+        } else {
+            if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
+                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
+                                                                   "change with %s csn has not yet been seen by this server; "
+                                                                   " last csn seen from that replica is %s\n",
+                              csn_as_string(csn, PR_FALSE, csnStr),
+                              csn_as_string(supplierCsn, PR_FALSE, csnStr));
+            }
+            rc = CL5_SUCCESS;
+        }
+    } else /* we have both purge and supplier csn */
+    {
+        if (csn_compare(csn, purgeCsn) < 0) /* the csn is below the purge point */
+        {
+            rc = CL5_PURGED_DATA;
+        } else {
+            if (csn_compare(csn, supplierCsn) <= 0) /* we should have the data but we don't */
+            {
+                if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
+                    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
+                                                                       "change with %s csn has been purged by this server; "
+                                                                       "the current purge point for that replica is %s\n",
+                                  csn_as_string(csn, PR_FALSE, csnStr),
+                                  csn_as_string(purgeCsn, PR_FALSE, csnStr));
+                }
+                rc = CL5_MISSING_DATA;
+            } else {
+                if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
+                    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5CheckMissingCSN - "
+                                                                       "change with %s csn has not yet been seen by this server; "
+                                                                       " last csn seen from that replica is %s\n",
+                                  csn_as_string(csn, PR_FALSE, csnStr),
+                                  csn_as_string(supplierCsn, PR_FALSE, csnStr));
+                }
+                rc = CL5_SUCCESS;
+            }
+        }
     }
-    object_release(file_obj);
-}
-
-static void
-_cl5DBFileInitialized(Object *file_obj)
-{
-    CL5DBFile *file;
-
-    PR_ASSERT(file_obj);
-
-    file = (CL5DBFile *)object_get_data(file_obj);
-    PR_ASSERT(file);
-    file->flags |= DB_FILE_INIT;
-}
 
-static int
-_cl5CompareDBFile(Object *el1, const void *el2)
-{
-    CL5DBFile *file;
-    const char *name;
+    if (supplierCsn)
+        csn_free(&supplierCsn);
 
-    PR_ASSERT(el1 && el2);
+    if (purgeCsn)
+        csn_free(&purgeCsn);
 
-    file = (CL5DBFile *)object_get_data(el1);
-    name = (const char *)el2;
-    return ((file->flags & DB_FILE_INIT) ? strcmp(file->name, name) : 1);
+    return rc;
 }
 
-/*
- * return 1: true (the "filename" ends with "ext")
- * return 0: false
- */
-static int
-_cl5FileEndsWith(const char *filename, const char *ext)
-{
-    char *p = NULL;
-    int flen = strlen(filename);
-    int elen = strlen(ext);
-    if (0 == flen || 0 == elen) {
-        return 0;
-    }
-    p = PL_strrstr(filename, ext);
-    if (NULL == p) {
-        return 0;
-    }
-    if (p - filename + elen == flen) {
-        return 1;
-    }
-    return 0;
-}
+/* Helper functions that work with individual changelog files */
 
 static int
-_cl5ExportFile(PRFileDesc *prFile, Object *obj)
+_cl5ExportFile(PRFileDesc *prFile, cldb_Handle *cldb)
 {
     int rc;
     void *iterator = NULL;
